<template>
  <div class="search-main">
    <q-input v-model="searchText" @keyup="onSearch" >
      <template v-slot:append>
        <q-icon name="search" class="search-icon" />
      </template>
    </q-input>
    <div class="search-content">
    <q-card flat bordered v-if="isReady">
      <q-card-section v-for="(article, index) in articles" class="q-pt-xs" :key="index">
        <q-card-section>
          <div class="text-overline">{{ article.toStringCategories() }}</div>
          <div class="text-h5 q-mt-sm q-mb-xs">{{ article.title }}</div>
          <div class="text-caption text-grey">{{ article.content }}</div>
          <q-card-section class="col-5 flex flex-center">
            <q-img class="rounded-borders" src="https://cdn.quasar.dev/img/parallax2.jpg"/>
          </q-card-section>
          <q-separator />
          <q-card-actions>
            <q-btn flat round icon="event" />
            <q-btn flat>
              <date-format :date="article.date" :type="'BASIC'"/>
            </q-btn>
            <q-btn flat color="primary">
              See more
            </q-btn>
          </q-card-actions>
          <q-separator />
        </q-card-section>
      </q-card-section>
    </q-card>
    </div>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'
import {Article} from "src/models/Article";
import {Profile} from "src/models/Profil";
import {Category} from "src/models/Category";
import DateFormat from "components/utils/DateFormat.vue";
@Component({
  components: {DateFormat}
})
export default class searchComponent extends Vue {
  @Prop({ type: Array, default: () => [] })  readonly articles!: Article[];

  private searchText: String = '';
  private isReady: Boolean = false;

  created(){
    let listCategories = [];
    for (let _i = 0; _i < 3; _i++) {
      let category = new Category();
      category.name = 'categ' + _i;
      listCategories.push(category)
    }
    for (let _i = 0; _i < 3; _i++) {
      let article = new Article();
      let profile = new Profile();
      profile.name = 'Flo';
      article.title = 'Article ' + _i;
      article.content = 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent laoreet maximus arcu sit amet semper. In dapibus justo orci, nec volutpat urna dictum eget. Morbi hendrerit quam mauris, vel efficitur enim ullamcorper quis. Ut ac ex nisi. Mauris ante tellus, consectetur vitae consequat et, consectetur et tortor.';
      article.profile = profile;
      article.category = listCategories;
      this.articles.push(article);
    }
    console.log(this.articles)
    this.isReady = true;
  }
  //Trigger for AUTOCOMPLETE search
  onSearch(){
    console.log(this.searchText)
  }

}
</script>



<style scoped>
.search-main{
  width: 400px;
  padding: 0.2vw;
}
.search-content{
  overflow: auto;
  height: 80vh;
}
.search-icon{
  cursor: pointer;
}
</style>
